Scala Standard Library2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  This is the documentation for the Scala standard library.

  This is the documentation for the Scala standard library.

  #### Package structure

  The scala package contains core types like `Int`, `Float`, `Array` or `Option` which are accessible in all Scala compilation units without explicit qualification or imports.

  Notable packages include:

  - `scala.collection` and its sub-packages contain Scala's collections framework
    - `scala.collection.immutable` - Immutable, sequential data-structures such as `Vector`, `List`, `Range`, `HashMap` or `HashSet`
    - `scala.collection.mutable` - Mutable, sequential data-structures such as `ArrayBuffer`, `StringBuilder`, `HashMap` or `HashSet`
    - `scala.collection.concurrent` - Mutable, concurrent data-structures such as `TrieMap`
    - `scala.collection.parallel.immutable` - Immutable, parallel data-structures such as `ParVector`, `ParRange`, `ParHashMap` or `ParHashSet`
    - `scala.collection.parallel.mutable` - Mutable, parallel data-structures such as `ParArray`, `ParHashMap`, `ParTrieMap` or `ParHashSet`
  - `scala.concurrent` - Primitives for concurrent programming such as `Futures` and `Promises`
  - `scala.io` - Input and output operations
  - `scala.math` - Basic math functions and additional numeric types like `BigInt` and `BigDecimal`
  - `scala.sys` - Interaction with other processes and the operating system
  - `scala.util.matching` - Regular expressions

  Other packages exist. See the complete list on the right.

  Additional parts of the standard library are shipped as separate libraries. These include:

  - `scala.reflect` - Scala's reflection API (scala-reflect.jar)
  - `scala.xml` - XML parsing, manipulation, and serialization (scala-xml.jar)
  - `scala.swing` - A convenient wrapper around Java's GUI framework called Swing (scala-swing.jar)
  - `scala.util.parsing` - Parser combinators (scala-parser-combinators.jar)

  #### Automatic imports

  Identifiers in the scala package and the `scala.Predef` object are always in scope by default.

  Some of these identifiers are type aliases provided as shortcuts to commonly used classes. For example, `List` is an alias for `scala.collection.immutable.List`.

  Other aliases refer to classes provided by the underlying platform. For example, on the JVM, `String` is an alias for `java.lang.String`.

  Definition Classes
    root
-  package scala

  Core Scala types.

  Core Scala types. They are always available without an explicit import.

  Definition Classes
    root
-  package collection

  Contains the base traits and objects needed to use and extend Scala's collection library.

  Contains the base traits and objects needed to use and extend Scala's collection library.

  #### Guide

  A detailed guide for using the collections library is available at http://docs.scala-lang.org/overviews/collections/introduction.html. Developers looking to extend the collections library can find a description of its architecture at http://docs.scala-lang.org/overviews/core/architecture-of-scala-collections.html.

  #### Using Collections

  It is convenient to treat all collections as either a scala.collection.Traversable or scala.collection.Iterable, as these traits define the vast majority of operations on a collection.

  Collections can, of course, be treated as specifically as needed, and the library is designed to ensure that the methods that transform collections will return a collection of the same type:

      scala> val array = Array(1,2,3,4,5,6)
      array: Array[Int] = Array(1, 2, 3, 4, 5, 6)

      scala> array map { _.toString }
      res0: Array[String] = Array(1, 2, 3, 4, 5, 6)

      scala> val list = List(1,2,3,4,5,6)
      list: List[Int] = List(1, 2, 3, 4, 5, 6)

      scala> list map { _.toString }
      res1: List[String] = List(1, 2, 3, 4, 5, 6)

  #### Creating Collections

  The most common way to create a collection is to use its companion object as a factory. The three most commonly used collections are scala.collection.Seq, scala.collection.immutable.Set, and scala.collection.immutable.Map. They can be used directly as shown below since their companion objects are all available as type aliases in either the scala package or in `scala.Predef`. New collections are created like this:

      scala> val seq = Seq(1,2,3,4,1)
      seq: Seq[Int] = List(1, 2, 3, 4, 1)

      scala> val set = Set(1,2,3,4,1)
      set: scala.collection.immutable.Set[Int] = Set(1, 2, 3, 4)

      scala> val map = Map(1 -> "one", 2 -> "two", 3 -> "three", 2 -> "too")
      map: scala.collection.immutable.Map[Int,String] = Map(1 -> one, 2 -> too, 3 -> three)

  It is also typical to prefer the scala.collection.immutable collections over those in scala.collection.mutable; the types aliased in the `scala.Predef` object are the immutable versions.

  Also note that the collections library was carefully designed to include several implementations of each of the three basic collection types. These implementations have specific performance characteristics which are described in the guide.

  The concrete parallel collections also have specific performance characteristics which are described in the parallel collections guide

  ##### Converting to and from Java Collections

  The scala.collection.JavaConverters object provides a collection of decorators that allow converting between Scala and Java collections using `asScala` and `asJava` methods.

  Definition Classes
    scala
-  package parallel

  Package object for parallel collections.

  Package object for parallel collections.

  Definition Classes
    collection
-  package immutable
  Definition Classes
    parallel
-  package mutable
  Definition Classes
    parallel
- AdaptiveWorkStealingForkJoinTasks
- AdaptiveWorkStealingTasks
- AdaptiveWorkStealingThreadPoolTasks
- CollectionsHaveToParArray
- Combiner
- CombinerFactory
- CompositeThrowable
- ExecutionContextTaskSupport
- ExecutionContextTasks
- FactoryOps
- ForkJoinTaskSupport
- ForkJoinTasks
- FutureThreadPoolTasks
- HavingForkJoinPool
- IterableSplitter
- ParIterable
- ParIterableLike
- ParMap
- ParMapLike
- ParSeq
- ParSeqLike
- ParSet
- ParSetLike
- PreciseSplitter
- SeqSplitter
- Splitter
- Task
- TaskSupport
- Tasks
- ThreadPoolTaskSupport
- ThreadPoolTasks
- ThrowableOps
- TraversableOps

t

scala.collection.parallel

# ParMapLike 

###

#### trait ParMapLike[K, +V, +Repr <: ParMapLike[K, V, Repr, Sequential] with ParMap[K, V], +Sequential <: Map[K, V] with MapLike[K, V, Sequential]] extends GenMapLike[K, V, Repr] with ParIterableLike[(K, V), Repr, Sequential]

A template trait for mutable parallel maps. This trait is to be mixed in with concrete parallel maps to override the representation type.

The higher-order functions passed to certain operations may contain side-effects. Since implementations of bulk operations may not be sequential, this means that side-effects may not be predictable and may produce data-races, deadlocks or invalidation of state if care is not taken. It is up to the programmer to either avoid using side-effects or to use some form of synchronization when accessing mutable data.

K

  the key type of the map

V

  the value type of the map

Self Type
  ParMapLike[K, V, Repr, Sequential]
Source
  ParMapLike.scala

Linear Supertypes
ParIterableLike[(K, V), Repr, Sequential], HasNewCombiner[(K, V), Repr], Parallel, CustomParallelizable[(K, V), Repr], GenMapLike[K, V, Repr], Equals, GenIterableLike[(K, V), Repr], GenTraversableLike[(K, V), Repr], Parallelizable[(K, V), Repr], GenTraversableOnce[(K, V)], AnyRef, Any
Known Subclasses
ParMap, WithDefault, ParHashMap, ParMap, WithDefault, ParHashMap, ParMap, WithDefault, ParMapLike, ParTrieMap
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. ParMapLike
2. ParIterableLike
3. HasNewCombiner
4. Parallel
5. CustomParallelizable
6. GenMapLike
7. Equals
8. GenIterableLike
9. GenTraversableLike
10. Parallelizable
11. GenTraversableOnce
12. AnyRef
13. Any

Implicitly

1. by CollectionsHaveToParArray
2. by any2stringadd
3. by StringFormat
4. by Ensuring
5. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1.  trait Accessor [R, Tp] extends StrictSplitterCheckTask[R, Tp]

   Standard accessor task that iterates over the elements of the collection.

   Standard accessor task that iterates over the elements of the collection.

   R

     type of the result of this method (`R` for result).

   Tp

     the representation type of the task at hand.

   Attributes
     protected
   Definition Classes
     ParIterableLike
2.  class Aggregate [S] extends Accessor[S, Aggregate[S]]
   Attributes
     protected[this]
   Definition Classes
     ParIterableLike
3.  trait BuilderOps [Elem, To] extends AnyRef
   Definition Classes
     ParIterableLike
4.  class Collect [S, That] extends Transformer[Combiner[S, That], Collect[S, That]]
   Attributes
     protected[this]
   Definition Classes
     ParIterableLike
5.  abstract class Composite [FR, SR, R, First <: StrictSplitterCheckTask[FR, _], Second <: StrictSplitterCheckTask[SR, _]] extends NonDivisibleTask[R, Composite[FR, SR, R, First, Second]]
   Attributes
     protected[this]
   Definition Classes
     ParIterableLike
6.  class Copy [U >: T, That] extends Transformer[Combiner[U, That], Copy[U, That]]
   Attributes
     protected
   Definition Classes
     ParIterableLike
7.  class CopyToArray [U >: T, This >: Repr] extends Accessor[Unit, CopyToArray[U, This]]
   Attributes
     protected[this]
   Definition Classes
     ParIterableLike
8.  class Count extends Accessor[Int, Count]
   Attributes
     protected[this]
   Definition Classes
     ParIterableLike
9.  class CreateScanTree [U >: T] extends Transformer[ScanTree[U], CreateScanTree[U]]
   Attributes
     protected[this]
   Definition Classes
     ParIterableLike
10.  class Drop [U >: T, This >: Repr] extends Transformer[Combiner[U, This], Drop[U, This]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
11.  class Exists extends Accessor[Boolean, Exists]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
12.  class Filter [U >: T, This >: Repr] extends Transformer[Combiner[U, This], Filter[U, This]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
13.  class FilterNot [U >: T, This >: Repr] extends Transformer[Combiner[U, This], FilterNot[U, This]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
14.  class Find [U >: T] extends Accessor[Option[U], Find[U]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
15.  class FlatMap [S, That] extends Transformer[Combiner[S, That], FlatMap[S, That]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
16.  class Fold [U >: T] extends Accessor[U, Fold[U]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
17.  class Forall extends Accessor[Boolean, Forall]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
18.  class Foreach [S] extends Accessor[Unit, Foreach[S]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
19.  class FromScanTree [U >: T, That] extends StrictSplitterCheckTask[Combiner[U, That], FromScanTree[U, That]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
20.  class GroupBy [K, U >: T] extends Transformer[HashMapCombiner[K, U], GroupBy[K, U]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
21.  class Map [S, That] extends Transformer[Combiner[S, That], Map[S, That]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
22.  class Max [U >: T] extends Accessor[Option[U], Max[U]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
23.  class Min [U >: T] extends Accessor[Option[U], Min[U]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
24.  trait NonDivisible [R] extends NonDivisibleTask[R, NonDivisible[R]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
25.  trait NonDivisibleTask [R, Tp] extends StrictSplitterCheckTask[R, Tp]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
26.  abstract class ParComposite [FR, SR, R, First <: StrictSplitterCheckTask[FR, _], Second <: StrictSplitterCheckTask[SR, _]] extends Composite[FR, SR, R, First, Second]

    Performs two tasks in parallel, and waits for both to finish.

    Performs two tasks in parallel, and waits for both to finish.

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
27.  class Partition [U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Combiner[U, This]), Partition[U, This]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
28.  class Product [U >: T] extends Accessor[U, Product[U]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
29.  class Reduce [U >: T] extends Accessor[Option[U], Reduce[U]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
30.  abstract class ResultMapping [R, Tp, R1] extends NonDivisibleTask[R1, ResultMapping[R, Tp, R1]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
31.  case class ScanLeaf [U >: T](pit: IterableSplitter[U], op: (U, U) ⇒ U, from: Int, len: Int, prev: Option[ScanLeaf[U]], acc: U) extends ScanTree[U] with scala.Product with Serializable
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
32.  case class ScanNode [U >: T](left: ScanTree[U], right: ScanTree[U]) extends ScanTree[U] with scala.Product with Serializable
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
33.  trait ScanTree [U >: T] extends AnyRef
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
34.  abstract class SeqComposite [FR, SR, R, First <: StrictSplitterCheckTask[FR, _], Second <: StrictSplitterCheckTask[SR, _]] extends Composite[FR, SR, R, First, Second]

    Sequentially performs one task after another.

    Sequentially performs one task after another.

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
35.  trait SignallingOps [PI <: DelegatedSignalling] extends AnyRef
    Definition Classes
      ParIterableLike
36.  class Slice [U >: T, This >: Repr] extends Transformer[Combiner[U, This], Slice[U, This]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
37.  class Span [U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Combiner[U, This]), Span[U, This]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
38.  class SplitAt [U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Combiner[U, This]), SplitAt[U, This]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
39.  trait StrictSplitterCheckTask [R, Tp] extends Task[R, Tp]
    Attributes
      protected
    Definition Classes
      ParIterableLike
40.  class Sum [U >: T] extends Accessor[U, Sum[U]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
41.  class Take [U >: T, This >: Repr] extends Transformer[Combiner[U, This], Take[U, This]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
42.  class TakeWhile [U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Boolean), TakeWhile[U, This]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
43.  trait TaskOps [R, Tp] extends AnyRef
    Definition Classes
      ParIterableLike
44.  class ToParCollection [U >: T, That] extends Transformer[Combiner[U, That], ToParCollection[U, That]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
45.  class ToParMap [K, V, That] extends Transformer[Combiner[(K, V), That], ToParMap[K, V, That]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
46.  trait Transformer [R, Tp] extends Accessor[R, Tp]
    Attributes
      protected
    Definition Classes
      ParIterableLike
47.  class Zip [U >: T, S, That] extends Transformer[Combiner[(U, S), That], Zip[U, S, That]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
48.  class ZipAll [U >: T, S, That] extends Transformer[Combiner[(U, S), That], ZipAll[U, S, That]]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
49.  class DefaultKeySet extends ParSet[K]
    Attributes
      protected
50.  class DefaultValuesIterable extends ParIterable[V]
    Attributes
      protected
51.  type SSCTask[R, Tp] = StrictSplitterCheckTask[R, Tp]
    Definition Classes
      ParIterableLike

### Abstract Value Members

1.  abstract def +[V1 >: V](kv: (K, V1)): GenMap[K, V1]
   Definition Classes
     GenMapLike
2.  abstract def -(key: K): Repr
   Definition Classes
     GenMapLike
3.  abstract def empty: Repr
4.  abstract def get(key: K): Option[V]
   Definition Classes
     GenMapLike
5.  abstract def newCombiner: Combiner[(K, V), Repr]
   Attributes
     protected[this]
   Definition Classes
     HasNewCombiner
6.  abstract def seq: Sequential
   Definition Classes
     ParIterableLike → Parallelizable → GenTraversableOnce
7.  abstract def size: Int

   The size of this general collection.

   The size of this general collection.

   Note: will not terminate for infinite-sized collections.

   returns

     the number of elements in this general collection.

   Definition Classes
     GenTraversableLike → GenTraversableOnce
8.  abstract def splitter: IterableSplitter[(K, V)]

   Creates a new parallel iterator used to traverse the elements of this parallel collection.

   Creates a new parallel iterator used to traverse the elements of this parallel collection. This iterator is more specific than the iterator of the returned by `iterator`, and augmented with additional accessor and transformer methods.

   returns

     a parallel iterator

   Attributes
     protected[scala.collection.parallel]
   Definition Classes
     ParIterableLike
9.  abstract def stringPrefix: String

   Defines the prefix of this object's `toString` representation.

   Defines the prefix of this object's `toString` representation.

   returns

     a string representation which starts the result of `toString` applied to this general collection. By default the string prefix is the simple name of the collection class general collection.

   Definition Classes
     GenTraversableLike

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any
2.  final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any
3.  def ++[U >: (K, V), That](that: GenTraversableOnce[U])(implicit bf: CanBuildFrom[Repr, U, That]): That

   Returns a new parallel iterable containing the elements from the left hand operand followed by the elements from the right hand operand.

   Returns a new parallel iterable containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the parallel iterable is the most specific superclass encompassing the element types of the two operands.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this parallel iterable followed by all elements of `that`.

   Definition Classes
     ParIterableLike → GenTraversableLike
4.  def ->[B](y: B): (ParMapLike[K, V, Repr, Sequential], B)
   Implicit
     This member is added by an implicit conversion from ParMapLike[K, V, Repr, Sequential] to ArrowAssoc[ParMapLike[K, V, Repr, Sequential]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  def /:[S](z: S)(op: (S, (K, V)) ⇒ S): S

   Applies a binary operator to a start value and all elements of this parallel iterable, going left to right.

   Applies a binary operator to a start value and all elements of this parallel iterable, going left to right.

   Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

       scala> val a = List(1,2,3,4)
       a: List[Int] = List(1, 2, 3, 4)

       scala> val b = (5 /: a)(_+_)
       b: Int = 15

       scala> val c = (5 /: a)((x,y) => x + y)
       c: Int = 15

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

   z

     the start value.

   op

     the binary operator.

   returns

     the result of inserting `op` between consecutive elements of this parallel iterable, going left to right with the start value `z` on the left:

         op(...op(op(z, x_1), x_2), ..., x_n)

     where `x1, ..., xn` are the elements of this parallel iterable.

   Definition Classes
     ParIterableLike → GenTraversableOnce
6.  def :\[S](z: S)(op: ((K, V), S) ⇒ S): S

   Applies a binary operator to all elements of this parallel iterable and a start value, going right to left.

   Applies a binary operator to all elements of this parallel iterable and a start value, going right to left.

   Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

       scala> val a = List(1,2,3,4)
       a: List[Int] = List(1, 2, 3, 4)

       scala> val b = (a :\ 5)(_+_)
       b: Int = 15

       scala> val c = (a :\ 5)((x,y) => x + y)
       c: Int = 15

   z

     the start value

   op

     the binary operator

   returns

     the result of inserting `op` between consecutive elements of this parallel iterable, going right to left with the start value `z` on the right:

         op(x_1, op(x_2, ... op(x_n, z)...))

     where `x1, ..., xn` are the elements of this parallel iterable.

   Definition Classes
     ParIterableLike → GenTraversableOnce
7.  final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any
8.  def aggregate[S](z: ⇒ S)(seqop: (S, (K, V)) ⇒ S, combop: (S, S) ⇒ S): S

   Aggregates the results of applying an operator to subsequent elements.

   Aggregates the results of applying an operator to subsequent elements.

   This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked arbitrary number of times.

   For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the set, while `combop` would concatenate two sets from different partitions together. The initial value `z` would be an empty set.

       pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

   Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

   S

     the type of accumulated results

   z

     the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation) and may be evaluated more than once

   seqop

     an operator used to accumulate results within a partition

   combop

     an associative operator used to combine results from different partitions

   Definition Classes
     ParIterableLike → GenTraversableOnce
9.  def apply(key: K): V
   Definition Classes
     ParMapLike → GenMapLike
10.  final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

11.  def bf2seq[S, That](bf: CanBuildFrom[Repr, S, That]): CanBuildFrom[Sequential, S, That]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
12.  implicit def builder2ops[Elem, To](cb: Builder[Elem, To]): BuilderOps[Elem, To]
    Attributes
      protected
    Definition Classes
      ParIterableLike
13.  def canEqual(other: Any): Boolean
    Definition Classes
      ParIterableLike
14.  def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

15.  def collect[B](pf: PartialFunction[A, B]): ParMap[B]

    [use case] Builds a new collection by applying a partial function to all elements of this parallel map

    [use case]

    Builds a new collection by applying a partial function to all elements of this parallel map

    on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the parallel map .

    returns

      a new parallel map resulting from applying the given partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike
     Full Signature

    #### def collect[S, That](pf: PartialFunction[(K, V), S])(implicit bf: CanBuildFrom[Repr, S, That]): That

16.  def combinerFactory[S, That](cbf: () ⇒ Combiner[S, That]): CombinerFactory[S, That]
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
17.  def combinerFactory: CombinerFactory[(K, V), Repr]

    Creates a combiner factory.

    Creates a combiner factory. Each combiner factory instance is used once per invocation of a parallel transformer method for a single collection.

    The default combiner factory creates a new combiner every time it is requested, unless the combiner is thread-safe as indicated by its `canBeShared` method. In this case, the method returns a factory which returns the same combiner each time. This is typically done for concurrent parallel collections, the combiners of which allow thread safe access.

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
18.  def contains(key: K): Boolean

    Tests whether this map contains a binding for a key.

    Tests whether this map contains a binding for a key.

    key

      the key

    returns

      `true` if there is a binding for `key` in this map, `false` otherwise.

    Definition Classes
      ParMapLike → GenMapLike
19.  def copyToArray(xs: Array[A], start: Int, len: Int): Unit

    [use case] Copies the elements of this parallel map to an array.

    [use case]

    Copies the elements of this parallel map to an array. Fills the given array `xs` with at most `len` elements of this parallel map , starting at position `start`. Copying will stop once either the end of the current parallel map is reached, or the end of the target array is reached, or `len` elements have been copied.

    Note: will not terminate for infinite-sized collections.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      ParIterableLike → GenTraversableOnce
     Full Signature

    #### def copyToArray[U >: (K, V)](xs: Array[U], start: Int, len: Int): Unit

20.  def copyToArray(xs: Array[A], start: Int): Unit

    [use case] Copies the elements of this parallel map to an array.

    [use case]

    Copies the elements of this parallel map to an array. Fills the given array `xs` with values of this parallel map , beginning at index `start`. Copying will stop once either the end of the current parallel map is reached, or the end of the target array is reached.

    Note: will not terminate for infinite-sized collections.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      ParIterableLike → GenTraversableOnce
     Full Signature

    #### def copyToArray[U >: (K, V)](xs: Array[U], start: Int): Unit

21.  def copyToArray(xs: Array[A]): Unit

    [use case] Copies the elements of this parallel map to an array.

    [use case]

    Copies the elements of this parallel map to an array. Fills the given array `xs` with values of this parallel map . Copying will stop once either the end of the current parallel map is reached, or the end of the target array is reached.

    Note: will not terminate for infinite-sized collections.

    xs

      the array to fill.

    Definition Classes
      ParIterableLike → GenTraversableOnce
     Full Signature

    #### def copyToArray[U >: (K, V)](xs: Array[U]): Unit

22.  def count(p: ((K, V)) ⇒ Boolean): Int

    Counts the number of elements in the parallel iterable which satisfy a predicate.

    Counts the number of elements in the parallel iterable which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      ParIterableLike → GenTraversableOnce
23.  def debugBuffer: ArrayBuffer[String]
    Definition Classes
      ParIterableLike
24.  def default(key: K): V
    Definition Classes
      ParMapLike → GenMapLike
25.  implicit def delegatedSignalling2ops[PI <: DelegatedSignalling](it: PI): SignallingOps[PI]
    Attributes
      protected
    Definition Classes
      ParIterableLike
26.  def drop(n: Int): Repr

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      the number of elements to drop from this parallel iterable.

    returns

      a parallel iterable consisting of all elements of this parallel iterable except the first `n` ones, or else the empty parallel iterable, if this parallel iterable has less than `n` elements.

    Definition Classes
      ParIterableLike → GenTraversableLike
27.  def dropWhile(pred: ((K, V)) ⇒ Boolean): Repr

    Drops all elements in the longest prefix of elements that satisfy the predicate, and returns a collection composed of the remaining elements.

    Drops all elements in the longest prefix of elements that satisfy the predicate, and returns a collection composed of the remaining elements.

    This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state. The index flag is initially set to maximum integer value.

    pred

      the predicate used to test the elements

    returns

      a collection composed of all the elements after the longest prefix of elements in this parallel iterable that satisfy the predicate `pred`

    Definition Classes
      ParIterableLike → GenTraversableLike
28.  def ensuring(cond: (ParMapLike[K, V, Repr, Sequential]) ⇒ Boolean, msg: ⇒ Any): ParMapLike[K, V, Repr, Sequential]
    Implicit
      This member is added by an implicit conversion from ParMapLike[K, V, Repr, Sequential] to Ensuring[ParMapLike[K, V, Repr, Sequential]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
29.  def ensuring(cond: (ParMapLike[K, V, Repr, Sequential]) ⇒ Boolean): ParMapLike[K, V, Repr, Sequential]
    Implicit
      This member is added by an implicit conversion from ParMapLike[K, V, Repr, Sequential] to Ensuring[ParMapLike[K, V, Repr, Sequential]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
30.  def ensuring(cond: Boolean, msg: ⇒ Any): ParMapLike[K, V, Repr, Sequential]
    Implicit
      This member is added by an implicit conversion from ParMapLike[K, V, Repr, Sequential] to Ensuring[ParMapLike[K, V, Repr, Sequential]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
31.  def ensuring(cond: Boolean): ParMapLike[K, V, Repr, Sequential]
    Implicit
      This member is added by an implicit conversion from ParMapLike[K, V, Repr, Sequential] to Ensuring[ParMapLike[K, V, Repr, Sequential]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
32.  final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
33.  def equals(that: Any): Boolean

    Compares two maps structurally; i.e., checks if all mappings contained in this map are also contained in the other map, and vice versa.

    Compares two maps structurally; i.e., checks if all mappings contained in this map are also contained in the other map, and vice versa.

    that

      the other map

    returns

      `true` if both maps contain exactly the same mappings, `false` otherwise.

    Definition Classes
      GenMapLike → Equals → AnyRef → Any
34.  def exists(p: ((K, V)) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some element of this parallel iterable.

    Tests whether a predicate holds for some element of this parallel iterable.

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    p

      a predicate used to test elements

    returns

      true if `p` holds for some element, false otherwise

    Definition Classes
      ParIterableLike → GenTraversableOnce
35.  def filter(pred: ((K, V)) ⇒ Boolean): Repr

    Selects all elements of this parallel iterable which satisfy a predicate.

    Selects all elements of this parallel iterable which satisfy a predicate.

    pred

      the predicate used to test elements.

    returns

      a new parallel iterable consisting of all elements of this parallel iterable that satisfy the given predicate `p`. Their order may not be preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike
36.  def filterKeys(p: (K) ⇒ Boolean): ParMap[K, V]

    Filters this map by retaining only keys satisfying a predicate.

    Filters this map by retaining only keys satisfying a predicate.

    p

      the predicate used to test keys

    returns

      an immutable map consisting only of those key value pairs of this map where the key satisfies the predicate `p`. The resulting map wraps the original map without copying any elements.

    Definition Classes
      ParMapLike → GenMapLike
37.  def filterNot(pred: ((K, V)) ⇒ Boolean): Repr

    Selects all elements of this parallel iterable which do not satisfy a predicate.

    Selects all elements of this parallel iterable which do not satisfy a predicate.

    pred

      the predicate used to test elements.

    returns

      a new parallel iterable consisting of all elements of this parallel iterable that do not satisfy the given predicate `p`. Their order may not be preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike
38.  def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

39.  def find(p: ((K, V)) ⇒ Boolean): Option[(K, V)]

    Finds some element in the collection for which the predicate holds, if such an element exists.

    Finds some element in the collection for which the predicate holds, if such an element exists. The element may not necessarily be the first such element in the iteration order.

    If there are multiple elements obeying the predicate, the choice is nondeterministic.

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    p

      predicate used to test the elements

    returns

      an option value with the element if such an element exists, or `None` otherwise

    Definition Classes
      ParIterableLike → GenTraversableOnce
40.  def flatMap[B](f: (A) ⇒ GenTraversableOnce[B]): ParMap[B]

    [use case] Builds a new collection by applying a function to all elements of this parallel map

    [use case]

    Builds a new collection by applying a function to all elements of this parallel map

    and using the elements of the resulting collections.

    For example:

        def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of parallel map . This might cause unexpected results sometimes. For example:

        // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
        def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

        // lettersOf will return a Set[Char], not a Seq
        def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

        // xs will be an Iterable[Int]
        val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

        // ys will be a Map[Int, Int]
        val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new parallel map resulting from applying the given collection-valued function `f` to each element of this parallel map and concatenating the results.

    Definition Classes
      ParIterableLike → GenTraversableLike
     Full Signature

    #### def flatMap[S, That](f: ((K, V)) ⇒ GenTraversableOnce[S])(implicit bf: CanBuildFrom[Repr, S, That]): That

41.  def fold[U >: (K, V)](z: U)(op: (U, U) ⇒ U): U

    Folds the elements of this sequence using the specified associative binary operator.

    Folds the elements of this sequence using the specified associative binary operator. The order in which the elements are reduced is unspecified and may be nondeterministic.

    Note this method has a different signature than the `foldLeft` and `foldRight` methods of the trait `Traversable`. The result of folding may only be a supertype of this parallel collection's type parameter `T`.

    U

      a type parameter for the binary operator, a supertype of `T`.

    z

      a neutral element for the fold operation, it may be added to the result an arbitrary number of times, not changing the result (e.g. `Nil` for list concatenation, 0 for addition, or 1 for multiplication)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      ParIterableLike → GenTraversableOnce
42.  def foldLeft[S](z: S)(op: (S, (K, V)) ⇒ S): S

    Applies a binary operator to a start value and all elements of this parallel iterable, going left to right.

    Applies a binary operator to a start value and all elements of this parallel iterable, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this parallel iterable, going left to right with the start value `z` on the left:

          op(...op(z, x_1), x_2, ..., x_n)

      where `x1, ..., xn` are the elements of this parallel iterable. Returns `z` if this parallel iterable is empty.

    Definition Classes
      ParIterableLike → GenTraversableOnce
43.  def foldRight[S](z: S)(op: ((K, V), S) ⇒ S): S

    Applies a binary operator to all elements of this parallel iterable and a start value, going right to left.

    Applies a binary operator to all elements of this parallel iterable and a start value, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this parallel iterable, going right to left with the start value `z` on the right:

          op(x_1, op(x_2, ... op(x_n, z)...))

      where `x1, ..., xn` are the elements of this parallel iterable. Returns `z` if this parallel iterable is empty.

    Definition Classes
      ParIterableLike → GenTraversableOnce
44.  def forall(p: ((K, V)) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this parallel iterable.

    Tests whether a predicate holds for all elements of this parallel iterable.

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    p

      a predicate used to test elements

    returns

      true if `p` holds for all elements, false otherwise

    Definition Classes
      ParIterableLike → GenTraversableOnce
45.  def foreach[U](f: ((K, V)) ⇒ U): Unit

    Applies a function `f` to all the elements of parallel iterable in an undefined order.

    Applies a function `f` to all the elements of parallel iterable in an undefined order.

    U

      the result type of the function applied to each element, which is always discarded

    f

      function applied to each element

    Definition Classes
      ParIterableLike → GenTraversableLike → GenTraversableOnce
46.  def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit
      This member is added by an implicit conversion from ParMapLike[K, V, Repr, Sequential] to StringFormat[ParMapLike[K, V, Repr, Sequential]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
47.  final def getClass(): Class[_]

    Returns the runtime class representation of the object.

    Returns the runtime class representation of the object.

    returns

      a class object corresponding to the runtime type of the receiver.

    Definition Classes
      AnyRef → Any
48.  def getOrElse(key: K, default: ⇒ V): V

    [use case] Returns the value associated with a key, or a default value if the key is not contained in the map.

    [use case]

    Returns the value associated with a key, or a default value if the key is not contained in the map.

    key

      the key.

    default

      a computation that yields a default value in case no binding for `key` is found in the map.

    returns

      the value associated with `key` if it exists, otherwise the result of the `default` computation.

    Definition Classes
      ParMapLike → GenMapLike
     Full Signature

    #### def getOrElse[U >: V](key: K, default: ⇒ U): U

49.  def groupBy[K](f: ((K, V)) ⇒ K): immutable.ParMap[K, Repr]

    Partitions this parallel iterable into a map of parallel iterables according to some discriminator function.

    Partitions this parallel iterable into a map of parallel iterables according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new parallel iterable.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to parallel iterables such that the following invariant holds:

          (xs groupBy f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a parallel iterable of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      ParIterableLike → GenTraversableLike
50.  def hasDefiniteSize: Boolean

    Tests whether this parallel iterable is known to have a finite size.

    Tests whether this parallel iterable is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end. Non-empty Iterators usually return `false` even if they were created from a collection with a known finite size.

    Note: many collection methods will not work on collections of infinite sizes. The typical failure mode is an infinite loop. These methods always attempt a traversal without checking first that `hasDefiniteSize` returns `true`. However, checking `hasDefiniteSize` can provide an assurance that size is well-defined and non-termination is not a concern.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

    Definition Classes
      ParIterableLike → GenTraversableOnce
51.  def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      GenMapLike → AnyRef → Any
52.  def head: (K, V)

    Selects the first element of this parallel iterable.

    Selects the first element of this parallel iterable.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this parallel iterable.

    Definition Classes
      ParIterableLike → GenTraversableLike
    Exceptions thrown

      `NoSuchElementException` if the parallel iterable is empty.

53.  def headOption: Option[(K, V)]

    Optionally selects the first element.

    Optionally selects the first element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this parallel iterable if it is nonempty, `None` if it is empty.

    Definition Classes
      ParIterableLike → GenTraversableLike
54.  def init: Repr

    Selects all elements except the last.

    Selects all elements except the last.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      a parallel iterable consisting of all elements of this parallel iterable except the last one.

    Definition Classes
      ParIterableLike → GenTraversableLike
    Exceptions thrown

      `UnsupportedOperationException` if the parallel iterable is empty.

55.  def initTaskSupport(): Unit
    Attributes
      protected
    Definition Classes
      ParIterableLike
56.  def isDefinedAt(key: K): Boolean

    Tests whether this map contains a binding for a key.

    Tests whether this map contains a binding for a key. This method, which implements an abstract method of trait `PartialFunction`, is equivalent to `contains`.

    key

      the key

    returns

      `true` if there is a binding for `key` in this map, `false` otherwise.

    Definition Classes
      ParMapLike → GenMapLike
57.  def isEmpty: Boolean

    Tests whether the parallel iterable is empty.

    Tests whether the parallel iterable is empty.

    Note: Implementations in subclasses that are not repeatedly traversable must take care not to consume any elements when `isEmpty` is called.

    returns

      `true` if the parallel iterable contains no elements, `false` otherwise.

    Definition Classes
      ParIterableLike → GenTraversableOnce
58.  final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any
59.  def isStrictSplitterCollection: Boolean

    Denotes whether this parallel collection has strict splitters.

    Denotes whether this parallel collection has strict splitters.

    This is true in general, and specific collection instances may choose to override this method. Such collections will fail to execute methods which rely on splitters being strict, i.e. returning a correct value in the `remaining` method.

    This method helps ensure that such failures occur on method invocations, rather than later on and in unpredictable ways.

    Definition Classes
      ParIterableLike
60.  final def isTraversableAgain: Boolean

    Tests whether this parallel iterable can be repeatedly traversed.

    Tests whether this parallel iterable can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      ParIterableLike → GenTraversableLike → GenTraversableOnce
61.  def iterator: Splitter[(K, V)]

    Creates a new split iterator used to traverse the elements of this collection.

    Creates a new split iterator used to traverse the elements of this collection.

    By default, this method is implemented in terms of the protected `splitter` method.

    returns

      a split iterator

    Definition Classes
      ParIterableLike → GenIterableLike
62.  def keySet: ParSet[K]
    Definition Classes
      ParMapLike → GenMapLike
63.  def keys: ParIterable[K]

    Collects all keys of this map in an iterable collection.

    Collects all keys of this map in an iterable collection.

    returns

      the keys of this map as an iterable.

    Definition Classes
      ParMapLike → GenMapLike
64.  def keysIterator: IterableSplitter[K]

    Creates an iterator for all keys.

    Creates an iterator for all keys.

    returns

      an iterator over all keys.

    Definition Classes
      ParMapLike → GenMapLike
65.  def last: (K, V)

    Selects the last element.

    Selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      The last element of this parallel iterable.

    Definition Classes
      ParIterableLike → GenTraversableLike
    Exceptions thrown

      `NoSuchElementException` If the parallel iterable is empty.

66.  def lastOption: Option[(K, V)]

    Optionally selects the last element.

    Optionally selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the last element of this parallel iterable$ if it is nonempty, `None` if it is empty.

    Definition Classes
      ParIterableLike → GenTraversableLike
67.  def map[B](f: (A) ⇒ B): ParMap[B]

    [use case] Builds a new collection by applying a function to all elements of this parallel map .

    [use case]

    Builds a new collection by applying a function to all elements of this parallel map .

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new parallel map resulting from applying the given function `f` to each element of this parallel map and collecting the results.

    Definition Classes
      ParIterableLike → GenTraversableLike
     Full Signature

    #### def map[S, That](f: ((K, V)) ⇒ S)(implicit bf: CanBuildFrom[Repr, S, That]): That

68.  def mapValues[S](f: (V) ⇒ S): ParMap[K, S]

    Transforms this map by applying a function to every retrieved value.

    Transforms this map by applying a function to every retrieved value.

    f

      the function used to transform values of this map.

    returns

      a map view which maps every key of this map to `f(this(key))`. The resulting map wraps the original map without copying any elements.

    Definition Classes
      ParMapLike → GenMapLike
69.  def max: A

    [use case] Finds the largest element.

    [use case]

    Finds the largest element.

    returns

      the largest element of this parallel map .

    Definition Classes
      ParIterableLike → GenTraversableOnce
     Full Signature

    #### def max[U >: (K, V)](implicit ord: Ordering[U]): (K, V)

70.  def maxBy[B](f: (A) ⇒ B): A

    [use case] Finds the first element which yields the largest value measured by function f.

    [use case]

    Finds the first element which yields the largest value measured by function f.

    B

      The result type of the function f.

    f

      The measuring function.

    returns

      the first element of this parallel map with the largest value measured by function f.

    Definition Classes
      ParIterableLike → GenTraversableOnce
     Full Signature

    #### def maxBy[S](f: ((K, V)) ⇒ S)(implicit cmp: Ordering[S]): (K, V)

71.  def min: A

    [use case] Finds the smallest element.

    [use case]

    Finds the smallest element.

    returns

      the smallest element of this parallel map

    Definition Classes
      ParIterableLike → GenTraversableOnce
     Full Signature

    #### def min[U >: (K, V)](implicit ord: Ordering[U]): (K, V)

72.  def minBy[B](f: (A) ⇒ B): A

    [use case] Finds the first element which yields the smallest value measured by function f.

    [use case]

    Finds the first element which yields the smallest value measured by function f.

    B

      The result type of the function f.

    f

      The measuring function.

    returns

      the first element of this parallel map with the smallest value measured by function f.

    Definition Classes
      ParIterableLike → GenTraversableOnce
     Full Signature

    #### def minBy[S](f: ((K, V)) ⇒ S)(implicit cmp: Ordering[S]): (K, V)

73.  def mkString: String

    Displays all elements of this parallel iterable in a string.

    Displays all elements of this parallel iterable in a string.

    returns

      a string representation of this parallel iterable. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this parallel iterable follow each other without any separator string.

    Definition Classes
      ParIterableLike → GenTraversableOnce
74.  def mkString(sep: String): String

    Displays all elements of this parallel iterable in a string using a separator string.

    Displays all elements of this parallel iterable in a string using a separator string.

    sep

      the separator string.

    returns

      a string representation of this parallel iterable. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this parallel iterable are separated by the string `sep`.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("|") = "1|2|3"`

75.  def mkString(start: String, sep: String, end: String): String

    Displays all elements of this parallel iterable in a string using start, end, and separator strings.

    Displays all elements of this parallel iterable in a string using start, end, and separator strings.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      a string representation of this parallel iterable. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this parallel iterable are separated by the string `sep`.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

76.  final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
77.  def nonEmpty: Boolean

    Tests whether the parallel iterable is not empty.

    Tests whether the parallel iterable is not empty.

    returns

      `true` if the parallel iterable contains at least one element, `false` otherwise.

    Definition Classes
      ParIterableLike → GenTraversableOnce
78.  final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

79.  final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

80.  def par: Repr

    Returns a parallel implementation of this collection.

    Returns a parallel implementation of this collection.

    For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

    Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

    All parallel collections return a reference to themselves.

    returns

      a parallel implementation of this collection

    Definition Classes
      ParIterableLike → CustomParallelizable → Parallelizable
81.  def parCombiner: Combiner[(K, V), Repr]

    The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

    The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

    returns

      a combiner for the parallel collection of type `ParRepr`

    Attributes
      protected[this]
    Definition Classes
      CustomParallelizable → Parallelizable
82.  def partition(pred: ((K, V)) ⇒ Boolean): (Repr, Repr)

    Partitions this parallel iterable in two parallel iterables according to a predicate.

    Partitions this parallel iterable in two parallel iterables according to a predicate.

    pred

      the predicate on which to partition.

    returns

      a pair of parallel iterables: the first parallel iterable consists of all elements that satisfy the predicate `p` and the second parallel iterable consists of all elements that don't. The relative order of the elements in the resulting parallel iterables may not be preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike
83.  def product: A

    [use case] Multiplies up the elements of this collection.

    [use case]

    Multiplies up the elements of this collection.

    returns

      the product of all elements in this parallel map of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the parallel map and as result type of `product`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

    Definition Classes
      ParIterableLike → GenTraversableOnce
     Full Signature

    #### def product[U >: (K, V)](implicit num: Numeric[U]): U

84.  def reduce[U >: (K, V)](op: (U, U) ⇒ U): U

    Reduces the elements of this sequence using the specified associative binary operator.

    Reduces the elements of this sequence using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    Note this method has a different signature than the `reduceLeft` and `reduceRight` methods of the trait `Traversable`. The result of reducing may only be a supertype of this parallel collection's type parameter `T`.

    U

      A type parameter for the binary operator, a supertype of `T`.

    op

      A binary operator that must be associative.

    returns

      The result of applying reduce operator `op` between all the elements if the collection is nonempty.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Exceptions thrown

      `UnsupportedOperationException` if this parallel iterable is empty.

85.  def reduceLeft[U >: (K, V)](op: (U, (K, V)) ⇒ U): U
    Definition Classes
      ParIterableLike
86.  def reduceLeftOption[U >: (K, V)](op: (U, (K, V)) ⇒ U): Option[U]

    Optionally applies a binary operator to all elements of this parallel iterable, going left to right.

    Optionally applies a binary operator to all elements of this parallel iterable, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceLeft(op)` if this parallel iterable is nonempty, `None` otherwise.

    Definition Classes
      ParIterableLike → GenTraversableOnce
87.  def reduceOption[U >: (K, V)](op: (U, U) ⇒ U): Option[U]

    Optionally reduces the elements of this sequence using the specified associative binary operator.

    Optionally reduces the elements of this sequence using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    Note this method has a different signature than the `reduceLeftOption` and `reduceRightOption` methods of the trait `Traversable`. The result of reducing may only be a supertype of this parallel collection's type parameter `T`.

    U

      A type parameter for the binary operator, a supertype of `T`.

    op

      A binary operator that must be associative.

    returns

      An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

    Definition Classes
      ParIterableLike → GenTraversableOnce
88.  def reduceRight[U >: (K, V)](op: ((K, V), U) ⇒ U): U

    Applies a binary operator to all elements of this parallel iterable, going right to left.

    Applies a binary operator to all elements of this parallel iterable, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this parallel iterable, going right to left:

          op(x_1, op(x_2, ..., op(x_{n-1}, x_n)...))

      where `x1, ..., xn` are the elements of this parallel iterable.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Exceptions thrown

      `UnsupportedOperationException` if this parallel iterable is empty.

89.  def reduceRightOption[U >: (K, V)](op: ((K, V), U) ⇒ U): Option[U]

    Optionally applies a binary operator to all elements of this parallel iterable, going right to left.

    Optionally applies a binary operator to all elements of this parallel iterable, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceRight(op)` if this parallel iterable is nonempty, `None` otherwise.

    Definition Classes
      ParIterableLike → GenTraversableOnce
90.  def repr: Repr
    Definition Classes
      ParIterableLike → GenTraversableLike
91.  def reuse[S, That](oldc: Option[Combiner[S, That]], newc: Combiner[S, That]): Combiner[S, That]

    Optionally reuses an existing combiner for better performance.

    Optionally reuses an existing combiner for better performance. By default it doesn't - subclasses may override this behaviour. The provided combiner `oldc` that can potentially be reused will be either some combiner from the previous computational task, or `None` if there was no previous phase (in which case this method must return `newc`).

    oldc

      The combiner that is the result of the previous task, or `None` if there was no previous task.

    newc

      The new, empty combiner that can be used.

    returns

      Either `newc` or `oldc`.

    Attributes
      protected
    Definition Classes
      ParIterableLike
92.  def sameElements(that: GenIterable[A]): Boolean

    [use case] Checks if the other iterable collection contains the same elements in the same order as this parallel map .

    [use case]

    Checks if the other iterable collection contains the same elements in the same order as this parallel map .

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    Note: will not terminate for infinite-sized collections.

    that

      the collection to compare with.

    returns

      `true`, if both collections contain the same elements in the same order, `false` otherwise.

    Definition Classes
      ParIterableLike → GenIterableLike
     Full Signature

    #### def sameElements[U >: (K, V)](that: GenIterable[U]): Boolean

93.  def scan(z: (K, V))(op: ((K, V), (K, V)) ⇒ (K, V)): ParMap[(K, V)]

    [use case] Computes a prefix scan of the elements of the collection.

    [use case]

    Computes a prefix scan of the elements of the collection.

    Note: The neutral element `z` may be applied more than once.

    z

      neutral element for the operator `op`

    op

      the associative operator for the scan

    returns

      a new parallel map containing the prefix scan of the elements in this parallel map

    Definition Classes
      ParIterableLike → GenTraversableLike
     Full Signature

    #### def scan[U >: (K, V), That](z: U)(op: (U, U) ⇒ U)(implicit bf: CanBuildFrom[Repr, U, That]): That

94.  def scanBlockSize: Int
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
95.  def scanLeft[S, That](z: S)(op: (S, (K, V)) ⇒ S)(implicit bf: CanBuildFrom[Repr, S, That]): That

    Produces a collection containing cumulative results of applying the operator going left to right.

    Produces a collection containing cumulative results of applying the operator going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    That

      the actual type of the resulting collection

    z

      the initial value

    op

      the binary operator applied to the intermediate result and the element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      collection with intermediate results

    Definition Classes
      ParIterableLike → GenTraversableLike
96.  def scanRight[S, That](z: S)(op: ((K, V), S) ⇒ S)(implicit bf: CanBuildFrom[Repr, S, That]): That

    Produces a collection containing cumulative results of applying the operator going right to left.

    Produces a collection containing cumulative results of applying the operator going right to left. The head of the collection is the last cumulative result.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    Example:

        List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

    That

      the actual type of the resulting collection

    z

      the initial value

    op

      the binary operator applied to the intermediate result and the element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      collection with intermediate results

    Definition Classes
      ParIterableLike → GenTraversableLike
97.  def sequentially[S, That <: Parallel](b: (Sequential) ⇒ Parallelizable[S, That]): Repr
    Attributes
      protected[this]
    Definition Classes
      ParIterableLike
98.  def sizeHintIfCheap: Int

    The size of this collection or iterator, if it can be cheaply computed

    The size of this collection or iterator, if it can be cheaply computed

    returns

      the number of elements in this collection or iterator, or -1 if the size cannot be determined cheaply

    Attributes
      protected[scala.collection]
    Definition Classes
      GenTraversableOnce
99.  def slice(unc_from: Int, unc_until: Int): Repr

    Selects an interval of elements.

    Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

        from <= indexOf(x) < until

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    unc_from

      the lowest index to include from this parallel iterable.

    unc_until

      the lowest index to EXCLUDE from this parallel iterable.

    returns

      a parallel iterable containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this parallel iterable.

    Definition Classes
      ParIterableLike → GenTraversableLike
100.  def span(pred: ((K, V)) ⇒ Boolean): (Repr, Repr)

     Splits this parallel iterable into a prefix/suffix pair according to a predicate.

     Splits this parallel iterable into a prefix/suffix pair according to a predicate.

     This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state. The index flag is initially set to maximum integer value.

     pred

       the predicate used to test the elements

     returns

       a pair consisting of the longest prefix of the collection for which all the elements satisfy `pred`, and the rest of the collection

     Definition Classes
       ParIterableLike → GenTraversableLike
101.  def splitAt(n: Int): (Repr, Repr)

     Splits this parallel iterable into two at a given position.

     Splits this parallel iterable into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the position at which to split.

     returns

       a pair of parallel iterables consisting of the first `n` elements of this parallel iterable, and the other elements.

     Definition Classes
       ParIterableLike → GenTraversableLike
102.  def sum: A

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements in this parallel map of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the parallel map and as result type of `sum`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

     Definition Classes
       ParIterableLike → GenTraversableOnce
      Full Signature

     #### def sum[U >: (K, V)](implicit num: Numeric[U]): U

103.  final def synchronized[T0](arg0: ⇒ T0): T0
     Definition Classes
       AnyRef
104.  def tail: Repr

     Selects all elements except the first.

     Selects all elements except the first.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       a parallel iterable consisting of all elements of this parallel iterable except the first one.

     Definition Classes
       ParIterableLike → GenTraversableLike
     Exceptions thrown

       `UnsupportedOperationException` if the parallel iterable is empty.

105.  def take(n: Int): Repr

     Selects first n elements.

     Selects first n elements.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the number of elements to take from this parallel iterable.

     returns

       a parallel iterable consisting only of the first `n` elements of this parallel iterable, or else the whole parallel iterable, if it has less than `n` elements.

     Definition Classes
       ParIterableLike → GenTraversableLike
106.  def takeWhile(pred: ((K, V)) ⇒ Boolean): Repr

     Takes the longest prefix of elements that satisfy the predicate.

     Takes the longest prefix of elements that satisfy the predicate.

     This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state. The index flag is initially set to maximum integer value.

     pred

       the predicate used to test the elements

     returns

       the longest prefix of this parallel iterable of elements that satisfy the predicate `pred`

     Definition Classes
       ParIterableLike → GenTraversableLike
107.  implicit def task2ops[R, Tp](tsk: SSCTask[R, Tp]): TaskOps[R, Tp]
     Attributes
       protected
     Definition Classes
       ParIterableLike
108.  def tasksupport: TaskSupport

     The task support object which is responsible for scheduling and load-balancing tasks to processors.

     The task support object which is responsible for scheduling and load-balancing tasks to processors.

     Definition Classes
       ParIterableLike
     See also

       scala.collection.parallel.TaskSupport

109.  def tasksupport_=(ts: TaskSupport): Unit

     Changes the task support object which is responsible for scheduling and load-balancing tasks to processors.

     Changes the task support object which is responsible for scheduling and load-balancing tasks to processors.

     A task support object can be changed in a parallel collection after it has been created, but only during a quiescent period, i.e. while there are no concurrent invocations to parallel collection methods.

     Here is a way to change the task support of a parallel collection:

         import scala.collection.parallel._
         val pc = mutable.ParArray(1, 2, 3)
         pc.tasksupport = new ForkJoinTaskSupport(
           new java.util.concurrent.ForkJoinPool(2))

     Definition Classes
       ParIterableLike
     See also

       scala.collection.parallel.TaskSupport

110.  def to[Col[_]]: Col[A]

     [use case] Converts this parallel map into another by copying all elements.

     [use case]

     Converts this parallel map into another by copying all elements.

     Note: will not terminate for infinite-sized collections.

     Col

       The collection type to build.

     returns

       a new collection containing all elements of this parallel map .

     Definition Classes
       ParIterableLike → GenTraversableOnce
      Full Signature

     #### def to[Col[_]](implicit cbf: CanBuildFrom[Nothing, (K, V), Col[(K, V)]]): Col[(K, V)]

111.  def toArray: Array[A]

     [use case] Converts this parallel map to an array.

     [use case]

     Converts this parallel map to an array.

     Note: will not terminate for infinite-sized collections.

     returns

       an array containing all elements of this parallel map . An `ClassTag` must be available for the element type of this parallel map .

     Definition Classes
       ParIterableLike → GenTraversableOnce
      Full Signature

     #### def toArray[U >: (K, V)](implicit arg0: ClassTag[U]): Array[U]

112.  def toBuffer[U >: (K, V)]: Buffer[U]

     Uses the contents of this parallel iterable to create a new mutable buffer.

     Uses the contents of this parallel iterable to create a new mutable buffer.

     Note: will not terminate for infinite-sized collections.

     returns

       a buffer containing all elements of this parallel iterable.

     Definition Classes
       ParIterableLike → GenTraversableOnce
113.  def toIndexedSeq: immutable.IndexedSeq[(K, V)]

     Converts this parallel iterable to an indexed sequence.

     Converts this parallel iterable to an indexed sequence.

     Note: will not terminate for infinite-sized collections.

     returns

       an indexed sequence containing all elements of this parallel iterable.

     Definition Classes
       ParIterableLike → GenTraversableOnce
114.  def toIterable: ParIterable[(K, V)]

     Converts this parallel iterable to an iterable collection.

     Converts this parallel iterable to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     Note: will not terminate for infinite-sized collections.

     returns

       an `Iterable` containing all elements of this parallel iterable.

     Definition Classes
       ParIterableLike → GenTraversableOnce
115.  def toIterator: scala.Iterator[(K, V)]

     Returns an Iterator over the elements in this parallel iterable.

     Returns an Iterator over the elements in this parallel iterable. Will return the same Iterator if this instance is already an Iterator.

     Note: will not terminate for infinite-sized collections.

     returns

       an Iterator containing all elements of this parallel iterable.

     Definition Classes
       ParIterableLike → GenTraversableOnce
116.  def toList: List[(K, V)]

     Converts this parallel iterable to a list.

     Converts this parallel iterable to a list.

     Note: will not terminate for infinite-sized collections.

     returns

       a list containing all elements of this parallel iterable.

     Definition Classes
       ParIterableLike → GenTraversableOnce
117.  def toMap[T, U]: collection.Map[T, U]

     [use case] Converts this parallel map to a map.

     [use case]

     Converts this parallel map to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     Note: will not terminate for infinite-sized collections.

     returns

       a map of type `immutable.Map[T, U]` containing all key/value pairs of type `(T, U)` of this parallel map .

     Definition Classes
       ParIterableLike → GenTraversableOnce
      Full Signature

     #### def toMap[K, V](implicit ev: <:<[(K, V), (K, V)]): immutable.ParMap[K, V]

118.  def toParArray: ParArray[T]
     Implicit
       This member is added by an implicit conversion from ParMapLike[K, V, Repr, Sequential] to CollectionsHaveToParArray[ParMapLike[K, V, Repr, Sequential], T] performed by method CollectionsHaveToParArray in scala.collection.parallel. This conversion will take place only if an implicit value of type (ParMapLike[K, V, Repr, Sequential]) ⇒ GenTraversableOnce[T] is in scope.
     Definition Classes
       CollectionsHaveToParArray
119.  def toParCollection[U >: (K, V), That](cbf: () ⇒ Combiner[U, That]): That
     Attributes
       protected
     Definition Classes
       ParIterableLike
120.  def toParMap[K, V, That](cbf: () ⇒ Combiner[(K, V), That])(implicit ev: <:<[(K, V), (K, V)]): That
     Attributes
       protected
     Definition Classes
       ParIterableLike
121.  def toSeq: ParSeq[(K, V)]

     Converts this parallel iterable to a sequence.

     Converts this parallel iterable to a sequence. As with `toIterable`, it's lazy in this default implementation, as this `TraversableOnce` may be lazy and unevaluated.

     Note: will not terminate for infinite-sized collections.

     returns

       a sequence containing all elements of this parallel iterable.

     Definition Classes
       ParIterableLike → GenTraversableOnce
122.  def toSet[U >: (K, V)]: immutable.ParSet[U]

     Converts this parallel iterable to a set.

     Converts this parallel iterable to a set.

     Note: will not terminate for infinite-sized collections.

     returns

       a set containing all elements of this parallel iterable.

     Definition Classes
       ParIterableLike → GenTraversableOnce
123.  def toStream: Stream[(K, V)]

     Converts this parallel iterable to a stream.

     Converts this parallel iterable to a stream.

     returns

       a stream containing all elements of this parallel iterable.

     Definition Classes
       ParIterableLike → GenTraversableOnce
124.  def toString(): String

     Creates a String representation of this object.

     Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

     returns

       a String representation of the object.

     Definition Classes
       ParIterableLike → AnyRef → Any
125.  def toTraversable: GenTraversable[(K, V)]

     Converts this parallel iterable to an unspecified Traversable.

     Converts this parallel iterable to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     Note: will not terminate for infinite-sized collections.

     returns

       a Traversable containing all elements of this parallel iterable.

     Definition Classes
       ParIterableLike → GenTraversableOnce
126.  def toVector: Vector[(K, V)]

     Converts this parallel iterable to a Vector.

     Converts this parallel iterable to a Vector.

     Note: will not terminate for infinite-sized collections.

     returns

       a vector containing all elements of this parallel iterable.

     Definition Classes
       ParIterableLike → GenTraversableOnce
127.  def values: ParIterable[V]

     Collects all values of this map in an iterable collection.

     Collects all values of this map in an iterable collection.

     returns

       the values of this map as an iterable.

     Definition Classes
       ParMapLike → GenMapLike
128.  def valuesIterator: IterableSplitter[V]

     Creates an iterator for all values in this map.

     Creates an iterator for all values in this map.

     returns

       an iterator over all values that are associated with some key in this map.

     Definition Classes
       ParMapLike → GenMapLike
129.  final def wait(): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws( ... )
130.  final def wait(arg0: Long, arg1: Int): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws( ... )
131.  final def wait(arg0: Long): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws( ... )
132.  def withFilter(pred: ((K, V)) ⇒ Boolean): Repr
     Definition Classes
       ParIterableLike
133.  def wrap[R](body: ⇒ R): NonDivisible[R]
     Attributes
       protected
     Definition Classes
       ParIterableLike
134.  def zip[B](that: GenIterable[B]): ParMap[(A, B)]

     [use case] Returns a parallel map formed from this parallel map and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a parallel map formed from this parallel map and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new parallel map containing pairs consisting of corresponding elements of this parallel map and `that`. The length of the returned collection is the minimum of the lengths of this parallel map and `that`.

     Definition Classes
       ParIterableLike → GenIterableLike
      Full Signature

     #### def zip[U >: (K, V), S, That](that: GenIterable[S])(implicit bf: CanBuildFrom[Repr, (U, S), That]): That

135.  def zipAll[B](that: Iterable[B], thisElem: A, thatElem: B): ParMap[(A, B)]

     [use case] Returns a parallel map formed from this parallel map and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a parallel map formed from this parallel map and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this parallel map is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this parallel map .

     returns

       a new parallel map containing pairs consisting of corresponding elements of this parallel map and `that`. The length of the returned collection is the maximum of the lengths of this parallel map and `that`. If this parallel map is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this parallel map , `thatElem` values are used to pad the result.

     Definition Classes
       ParIterableLike → GenIterableLike
      Full Signature

     #### def zipAll[S, U >: (K, V), That](that: GenIterable[S], thisElem: U, thatElem: S)(implicit bf: CanBuildFrom[Repr, (U, S), That]): That

136.  def zipWithIndex: ParMap[(A, Int)]

     [use case] Zips this parallel map with its indices.

     [use case]

     Zips this parallel map with its indices.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       A new parallel map containing pairs consisting of all elements of this parallel map paired with their index. Indices start at `0`.

     Definition Classes
       ParIterableLike → GenIterableLike
      Full Signature

     #### def zipWithIndex[U >: (K, V), That](implicit bf: CanBuildFrom[Repr, (U, Int), That]): That

     Example:

     1. `List("a", "b", "c").zipWithIndex = List(("a", 0), ("b", 1), ("c", 2))`

137.  def →[B](y: B): (ParMapLike[K, V, Repr, Sequential], B)
     Implicit
       This member is added by an implicit conversion from ParMapLike[K, V, Repr, Sequential] to ArrowAssoc[ParMapLike[K, V, Repr, Sequential]] performed by method ArrowAssoc in scala.Predef.
     Definition Classes
       ArrowAssoc

### Shadowed Implicit Value Members

1.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from ParMapLike[K, V, Repr, Sequential] to any2stringadd[ParMapLike[K, V, Repr, Sequential]] performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (parMapLike: any2stringadd[ParMapLike[K, V, Repr, Sequential]]).+(other)

   Definition Classes
     any2stringadd

### Deprecated Value Members

1.  def view: IterableView[(K, V), Sequential]
   Definition Classes
     ParIterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.0) use .seq.view instead

### Inherited from ParIterableLike[(K, V), Repr, Sequential]

### Inherited from HasNewCombiner[(K, V), Repr]

### Inherited from Parallel

### Inherited from CustomParallelizable[(K, V), Repr]

### Inherited from GenMapLike[K, V, Repr]

### Inherited from Equals

### Inherited from GenIterableLike[(K, V), Repr]

### Inherited from GenTraversableLike[(K, V), Repr]

### Inherited from Parallelizable[(K, V), Repr]

### Inherited from GenTraversableOnce[(K, V)]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion CollectionsHaveToParArray from ParMapLike[K, V, Repr, Sequential] to CollectionsHaveToParArray[ParMapLike[K, V, Repr, Sequential], T]

### Inherited by implicit conversion any2stringadd from ParMapLike[K, V, Repr, Sequential] to any2stringadd[ParMapLike[K, V, Repr, Sequential]]

### Inherited by implicit conversion StringFormat from ParMapLike[K, V, Repr, Sequential] to StringFormat[ParMapLike[K, V, Repr, Sequential]]

### Inherited by implicit conversion Ensuring from ParMapLike[K, V, Repr, Sequential] to Ensuring[ParMapLike[K, V, Repr, Sequential]]

### Inherited by implicit conversion ArrowAssoc from ParMapLike[K, V, Repr, Sequential] to ArrowAssoc[ParMapLike[K, V, Repr, Sequential]]

### Ungrouped